/*
 * Copyright 2008 IHE International (http://www.ihe.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.ihe.gazelle.tm.financial.model;

import net.ihe.gazelle.common.model.AuditedObject;
import net.ihe.gazelle.hql.providers.EntityManagerService;
import net.ihe.gazelle.tm.systems.model.TestingSession;
import net.ihe.gazelle.users.model.Currency;
import net.ihe.gazelle.users.model.Institution;
import net.ihe.gazelle.users.model.Iso3166CountryCode;
import org.hibernate.annotations.Cache;
import org.hibernate.annotations.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.persistence.*;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.validation.constraints.Min;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * <b>Class Description : </b>Invoice<br>
 * <br>
 * This class describes the Invoice object, used by the Gazelle application. It corresponds to invoice reference for an institution participating to a testing session This invoice includes a invoice
 * ID number and a purchase order (known by the vendor) This class belongs to the TestManagement module.
 * <p/>
 * Invoice possesses the following attributes :
 * <ul>
 * <li><b>id</b> : id corresponding to the Invoice</li>
 * <li><b>institution</b> : Institution object (example : Philips, Agfa, etc...)</li>
 * <li><b>testingSession</b> : Testing session correlated to that invoice (eg. Connectathon Chicago 2008)</li>
 * <li><b>purchaseOrder</b> : Purchase order (known by vendor) correlated to that invoice</li>
 * <li><b>invoicePath</b> : Path where we can reach this invoice (as PDF,etc...)</li>
 * <li><b>note</b> : Note/comment concerning this invoice</li>
 * <li><b>etc...</b> :</li>
 * </ul>
 * </br> <b>Example of Invoice</b> : institution Agfa, Connectathon Chicago 2008, invoice # 123456, PO #454545<br>
 *
 * @author Jean-Renan Chatel / INRIA Rennes IHE development Project
 * @version 1.0 - 2008, December 16
 * @class Invoice.java
 * @package net.ihe.gazelle.tm.financial.model
 * @see > Jchatel@irisa.fr - http://www.ihe-europe.org
 */

@Entity
@Table(name = "tm_invoice", schema = "public", uniqueConstraints = {
        @UniqueConstraint(columnNames = {"testing_session_id", "institution_id"}),
        @UniqueConstraint(columnNames = "invoice_number")})
@org.hibernate.annotations.Entity(selectBeforeUpdate = true)
@SequenceGenerator(name = "tm_invoice_sequence", sequenceName = "tm_invoice_id_seq", allocationSize = 1)
@Cache(usage = CacheConcurrencyStrategy.TRANSACTIONAL)
public class Invoice extends AuditedObject implements java.io.Serializable {

    /**
     * Serial ID version of this object
     */
    private static final long serialVersionUID = 832427581009418150L;

    private static Logger log = LoggerFactory.getLogger(Invoice.class);

    {
        numberExtraParticipant = 0;
        numberParticipant = 0;
        numberSystem = 0;
    }

    // Attributes (existing in database as a column)
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "tm_invoice_sequence")
    private Integer id;

    /**
     * Institution of this invoice (an invoice is correlated to an institution and a testing session)
     */
    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "institution_id", nullable = false)
    @Fetch(value = FetchMode.SELECT)
    private Institution institution;

    /**
     * TestingSession of this invoice (an invoice is correlated to an institution and a testing session)
     */
    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "testing_session_id", nullable = false)
    @Fetch(value = FetchMode.SELECT)
    private TestingSession testingSession;

    /**
     * Purchase Order (used by vendor) for this Invoice
     */
    @Column(name = "purchase_order")
    private String purchaseOrder;

    /**
     * Date indicating when the Invoice has been generated by IHE
     */
    @Column(name = "invoice_generation_date")
    private Date invoiceGenerationDate;

    /**
     * Flag indicating if this invoice has been paid by the vendor
     */
    @Column(name = "invoice_paid")
    private Boolean invoicePaid;

    /**
     * Path indicating where to find the invoice on the Gazelle server (each invoice has a local back up)
     */
    @Column(name = "invoice_path")
    private String invoiceRelativePath;

    /**
     * VAT number, corresponding to the VAT code used by the company for this event (testing session)
     */
    @Column(name = "vat_number")
    private String vatNumber;

    /**
     * VAT country, corresponding to the VAT country used to search the VAT validity
     */
    @ManyToOne
    @JoinColumn(name = "vat_country")
    @Fetch(value = FetchMode.SELECT)
    private Iso3166CountryCode vatCountry;

    /**
     * VAT validity, Flag indicating if the VAT code is valid
     */
    @Column(name = "vat_validity")
    private Boolean vatValidity;

    /**
     * Flag indicating if the VAT is due
     */
    @Column(name = "vat_due")
    private Boolean vatDue;

    /** Amount of the VAT */
    /**
     * feesAmount + vatAmount - feesDiscount - feesPaid = feesDue
     */
    // Float gets only 1 Decimal in the database, BigDecimal gets 2 or more decimals (that s why we use BigDecimal)
    @Column(name = "vat_amount")
    private BigDecimal vatAmount = new BigDecimal(0);

    /**
     * Flag indicating if contract has been received by IHE from the vendor
     */
    @Column(name = "contract_received")
    private Boolean contractReceived;

    /**
     * Date indicating when contract has been received by IHE from the vendor
     */
    @Temporal(TemporalType.DATE)
    @Column(name = "contract_received_date", length = 13)
    private Date contractReceivedDate;

    /**
     * Flag indicating if invoice has been sent by IHE to the vendor
     */
    @Column(name = "invoice_sent")
    private Boolean invoiceSent;

    /**
     * Date indicating when invoice has been sent by IHE to the vendor
     */
    @Temporal(TemporalType.DATE)
    @Column(name = "invoice_sent_date", length = 13)
    private Date invoiceSentDate;

    /**
     * Number of this invoice (Integer keyword known by IHE)
     */
    // Float gets only 1 Decimal in the database, BigDecimal gets 2 or more decimals (that s why we use BigDecimal)
    @Column(name = "invoice_number")
    private Integer invoiceNumber;

    /**
     * Date indicating when invoice has been paid by the vendor
     */
    // Float gets only 1 Decimal in the database, BigDecimal gets 2 or more decimals (that s why we use BigDecimal)
    @Column(name = "invoice_payment_date")
    private Date invoicePaymentDate;

    /**
     * Fees already paid by the vendor to IHE
     */
    // Float gets only 1 Decimal in the database, BigDecimal gets 2 or more decimals (that s why we use BigDecimal)
    @Column(name = "fees_paid")
    private BigDecimal feesPaid = new BigDecimal(0);

    /** Fees discount */
    /** feesAmount + vatAmount - feesDiscount - feesPaid = feesDue */
    /**
     * feesDiscount is POSITIVE
     */
    // Float gets only 1 Decimal in the database, BigDecimal gets 2 or more decimals (that s why we use BigDecimal)
    @Column(name = "fees_discount")
    private BigDecimal feesDiscount = new BigDecimal(0);

    /**
     * Reasons for discount : Comment logged by the admin to explain a discount
     */
    @Column(name = "reasons_for_discount")
    private String reasonsForDiscount;

    /** Fees due by the vendor to IHE */
    /**
     * feesAmount + vatAmount - feesDiscount - feesPaid = feesDue
     */
    // Float gets only 1 Decimal in the database, BigDecimal gets 2 or more decimals (that s why we use BigDecimal)
    @Column(name = "fees_due")
    // this field SHOULD BE GENERATED through Hibernate, using the following formula
    // @org.hibernate.annotations.Formula("feesAmount + vatAmount - feesDiscount - feesPaid")
    private BigDecimal feesDue = new BigDecimal(0);

    /** Fees amount (calculated with systems/domains) */
    /**
     * feesAmount + vatAmount - feesDiscount - feesPaid = feesDue
     */
    // Float gets only 1 Decimal in the database, BigDecimal gets 2 or more decimals (that s why we use BigDecimal)
    @Column(name = "fees_amount")
    private BigDecimal feesAmount = new BigDecimal(0);

    /**
     * Currency of this invoice (USD, EUR)
     */
    @ManyToOne
    @JoinColumn(name = "currency")
    @Fetch(value = FetchMode.SELECT)
    private Currency currency;

    /**
     * Comment/Description or Note concerning that invoice
     */
    @Column(name = "note")
    private String note;

    @Column(name = "number_participant")
    private Integer numberParticipant;

    @Column(name = "number_extra_participant")
    private Integer numberExtraParticipant;

    @Column(name = "number_system")
    private Integer numberSystem;

    @Column(name = "last_contract_generation")
    private Long lastGenerationDate;

    @Column(name = "contract_out_of_date")
    private Boolean contractOutOfDate = true;

    private transient boolean validVATCountryFromFinancialContact = true;

    @Lob
    @Type(type = "text")
    @Column(name = "admin_invoice_notes")
    private String adminInvoiceNotes;

    @Lob
    @Type(type = "text")
    @Column(name = "special_instructions")
    private String specialInstructions;

    // Constructors

    public Invoice() {
    }

    public Invoice(Integer id, Institution institution, TestingSession testingSession, String purchaseOrder, String note) {
        super();
        this.id = id;
        this.institution = institution;
        this.testingSession = testingSession;
        this.purchaseOrder = purchaseOrder;
        this.note = note;
    }

    public Invoice(Integer id, Institution institution, TestingSession testingSession, String purchaseOrder,
                   String invoicePath, String note) {
        super();
        this.id = id;
        this.institution = institution;
        this.testingSession = testingSession;
        this.purchaseOrder = purchaseOrder;
        this.invoiceRelativePath = invoicePath;
        this.note = note;
    }

    public Invoice(Institution institution, TestingSession testingSession) {

        this.institution = institution;
        this.testingSession = testingSession;
    }

    public Invoice(Integer id, Institution institution, TestingSession testingSession, String purchaseOrder,
                   Date invoiceGenerationDate, Boolean invoicePaid, String invoicePath, String vatNumber,
                   Iso3166CountryCode vatCountry, Boolean vatValidity, Boolean vatDue, BigDecimal vatAmount,
                   Boolean contractReceived, Date contractReceivedDate, Boolean invoiceSent, Date invoiceSentDate,
                   Integer invoiceNumber, BigDecimal feesPaid, BigDecimal feesDiscount, BigDecimal feesDue,
                   BigDecimal feesAmount, Currency currency, String note) {
        this.id = id;
        this.institution = institution;
        this.testingSession = testingSession;
        this.purchaseOrder = purchaseOrder;
        this.invoiceGenerationDate = invoiceGenerationDate;
        this.invoicePaid = invoicePaid;
        this.invoiceRelativePath = invoicePath;
        this.vatNumber = vatNumber;
        this.vatCountry = vatCountry;
        this.vatValidity = vatValidity;
        this.vatDue = vatDue;
        this.vatAmount = vatAmount;
        this.contractReceived = contractReceived;
        this.contractReceivedDate = contractReceivedDate;
        this.invoiceSent = invoiceSent;
        this.invoiceSentDate = invoiceSentDate;
        this.invoiceNumber = invoiceNumber;
        this.feesPaid = feesPaid;
        this.feesDiscount = feesDiscount;
        this.feesDue = feesDue;
        this.feesAmount = feesAmount;
        this.currency = currency;
        this.note = note;
    }

    // *********************************************************
    // Getters and Setters : setup the DB columns properties
    // *********************************************************

    public String getSpecialInstructions() {
        return specialInstructions;
    }

    public void setSpecialInstructions(String specialInstructions) {
        this.specialInstructions = specialInstructions;
    }

    public String getAdminInvoiceNotes() {
        return adminInvoiceNotes;
    }

    public void setAdminInvoiceNotes(String adminInvoiceNotes) {
        this.adminInvoiceNotes = adminInvoiceNotes;
    }

    public Boolean getContractOutOfDate() {
        return contractOutOfDate;
    }

    public void setContractOutOfDate(Boolean contractOutOfDate) {
        this.contractOutOfDate = contractOutOfDate;
    }

    public Long getLastGenerationDate() {
        return lastGenerationDate;
    }

    public Date getLastGenerateDateAsDate() {
        if (lastGenerationDate != null) {
            return new Date(this.lastGenerationDate.longValue());
        }
        return null;
    }

    public void setLastGenerationDate(Long lastGenerationDate) {
        this.lastGenerationDate = lastGenerationDate;
    }

    public Integer getNumberParticipant() {
        if (numberParticipant == null) {
            return 0;
        }
        return numberParticipant;
    }

    public void setNumberParticipant(Integer numberParticipant) {
        this.numberParticipant = numberParticipant;
    }

    public Integer getNumberExtraParticipant() {
        if (numberExtraParticipant == null) {
            return 0;
        }
        return numberExtraParticipant;
    }

    public void setNumberExtraParticipant(Integer numberExtraParticipant) {
        this.numberExtraParticipant = numberExtraParticipant;
    }

    public Integer getNumberSystem() {
        if (numberSystem == null) {
            return 0;
        }
        return numberSystem;
    }

    public void setNumberSystem(Integer numberSystem) {
        this.numberSystem = numberSystem;
    }

    public void setValidVATCountryFromFinancialContact(boolean validVATCountryFromFinancialContact) {
        this.validVATCountryFromFinancialContact = validVATCountryFromFinancialContact;
    }

    public boolean isValidVATCountryFromFinancialContact() {
        return validVATCountryFromFinancialContact;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Institution getInstitution() {
        return institution;
    }

    public void setInstitution(Institution institution) {
        this.institution = institution;
    }

    public TestingSession getTestingSession() {
        return testingSession;
    }

    public void setTestingSession(TestingSession testingSession) {
        this.testingSession = testingSession;
    }

    public String getPurchaseOrder() {
        return purchaseOrder;
    }

    public void setPurchaseOrder(String purchaseOrder) {
        this.purchaseOrder = purchaseOrder;
    }

    public Date getInvoiceGenerationDate() {
        return invoiceGenerationDate;
    }

    public void setInvoiceGenerationDate(Date invoiceGenerationDate) {
        this.invoiceGenerationDate = invoiceGenerationDate;
    }

    public Boolean getInvoicePaid() {
        return invoicePaid;
    }

    public void setInvoicePaid(Boolean invoicePaid) {
        this.invoicePaid = invoicePaid;
    }

    public String getInvoiceRelativePath() {
        return invoiceRelativePath;
    }

    public void setInvoiceRelativePath(String invoicePath) {
        this.invoiceRelativePath = invoicePath;
    }

    public Date getInvoicePaymentDate() {
        return invoicePaymentDate;
    }

    public void setInvoicePaymentDate(Date invoicePaymentDate) {
        this.invoicePaymentDate = invoicePaymentDate;
    }

    public String getVatNumber() {
        return vatNumber;
    }

    public void setVatNumber(String vatNumber) {
        this.vatNumber = vatNumber;
    }

    public Iso3166CountryCode getVatCountry() {
        return vatCountry;
    }

    public void setVatCountry(Iso3166CountryCode vatCountry) {
        this.vatCountry = vatCountry;
    }

    public Boolean getVatValidity() {
        return vatValidity;
    }

    public void setVatValidity(Boolean vatValidity) {
        this.vatValidity = vatValidity;
    }

    public Boolean getVatDue() {
        return vatDue;
    }

    public void setVatDue(Boolean vatDue) {
        this.vatDue = vatDue;
    }

    public BigDecimal getVatAmount() {
        return vatAmount;
    }

    public void setVatAmount(BigDecimal vatAmount) {
        this.vatAmount = vatAmount;
    }

    public Boolean getContractReceived() {
        return contractReceived;
    }

    public void setContractReceived(Boolean contractReceived) {
        this.contractReceived = contractReceived;
    }

    public Date getContractReceivedDate() {
        return contractReceivedDate;
    }

    public void setContractReceivedDate(Date contractReceivedDate) {
        this.contractReceivedDate = contractReceivedDate;
    }

    public Boolean getInvoiceSent() {
        return invoiceSent;
    }

    public void setInvoiceSent(Boolean invoiceSent) {
        this.invoiceSent = invoiceSent;
    }

    public Date getInvoiceSentDate() {
        return invoiceSentDate;
    }

    public void setInvoiceSentDate(Date invoiceSentDate) {
        this.invoiceSentDate = invoiceSentDate;
    }

    public Integer getInvoiceNumber() {
        return invoiceNumber;
    }

    public void setInvoiceNumber(Integer invoiceNumber) {
        this.invoiceNumber = invoiceNumber;
    }

    public BigDecimal getFeesPaid() {
        return feesPaid;
    }

    public void setFeesPaid(BigDecimal feesPaid) {
        this.feesPaid = feesPaid;
    }

    public BigDecimal getFeesDiscount() {
        return feesDiscount;
    }

    public void setFeesDiscount(BigDecimal feesDiscount) {
        this.feesDiscount = feesDiscount;
    }

    public String getReasonsForDiscount() {
        return reasonsForDiscount;
    }

    public void setReasonsForDiscount(String reasonsForDiscount) {
        this.reasonsForDiscount = reasonsForDiscount;
    }

    public BigDecimal getFeesDue() {
        /** feesAmount + vatAmount - feesDiscount - feesPaid = feesDue */

        if ((feesAmount == null) || (vatAmount == null) || (feesDiscount == null) || (feesPaid == null)) {
            return new BigDecimal(0);
        }

        BigDecimal totalDue = feesAmount.add(vatAmount.add(feesDiscount.negate()).add(feesPaid.negate()));
        return totalDue;
    }

    public void setFeesDue(BigDecimal feesDue) {
        this.feesDue = feesDue;
    }

    public BigDecimal getFeesAmount() {
        return feesAmount;
    }

    public void setFeesAmount(BigDecimal feesAmount) {
        this.feesAmount = feesAmount;
    }

    public Currency getCurrency() {
        return currency;
    }

    public void setCurrency(Currency currency) {
        this.currency = currency;
    }

    public String getNote() {
        return note;
    }

    public void setNote(String note) {
        this.note = note;
    }

	/* Static methods for this object */

    /**
     * Delete in an Invoice object
     *
     * @param Invoice       : Invoice to delete (Could be for an institution)
     * @param EntityManager : Object managing persistence layer
     */
    public static void deleteInvoice(Invoice selectedInvoice) throws Exception {
        try

        {
            EntityManager em = EntityManagerService.provideEntityManager();
            em.remove(selectedInvoice);
            em.flush();
        } catch (Exception e) {
            log.error("deleteInvoice", e);

            throw new Exception(
                    "This object you want to delete possesses a Invoice which is already used for another Object. Please contact an administrator if you need to delete it. Error info :"
                            + e.getMessage(), e);
        }
    }

    /**
     * Delete all Invoices objects mapped with an Institution
     *
     * @param Institution   : This method will delete Invoices of this institution
     * @param EntityManager : Object managing persistence layer
     */
    public static void deleteAllInvoicesForCompany(Institution inst) throws Exception {
        Invoice oneInvoiceToBeDeleted = null;
        EntityManager em = EntityManagerService.provideEntityManager();

        List<Invoice> invoicesToBeDeleted = Invoice.getInvoicesForCompany(inst);
        for (int i = 0; i < invoicesToBeDeleted.size(); i++) {
            oneInvoiceToBeDeleted = em.find(Invoice.class, invoicesToBeDeleted.get(i).getId());
            Invoice.deleteInvoice(oneInvoiceToBeDeleted);
        }

        em.flush();
    }

    /**
     * List all Invoices mapped/matching with a Company
     *
     * @param inst   : This method will list Invoices for that Institution
     * @return List<Invoice> : List of all Invoices matching with this Institution
     */
    public static List<Invoice> getInvoicesForCompany(Institution inst) {
        if (inst == null) {
            log.error("Error getInvoicesForCompany - institution is null");
            return null;
        }
        InvoiceQuery q = new InvoiceQuery();
        q.institution().id().eq(inst.getId());

        return q.getList();
    }

    /**
     * List all Invoices mapped/matching with a TestingSession
     *
     * @param testingSession : This method will list Invoices for that TestingSession
     * @param em  : Object managing persistence layer
     * @return List<Invoice> : List of all Invoices matching with this TestingSession
     */
    @Deprecated
    public static List<Invoice> getInvoicesForTestingSession(TestingSession testingSession, EntityManager em) {
        return getInvoicesForTestingSession(testingSession);
    }

    public static List<Invoice> getInvoicesForTestingSession(TestingSession testingSession) {
        if (testingSession == null) {
            log.error("Error getInvoicesForTestingSession - testingSession is null");
            return null;
        }
        InvoiceQuery q = new InvoiceQuery();
        q.testingSession().id().eq(testingSession.getId());

        return q.getList();
    }


    /**
     * List all Invoices mapped/matching with a Company and a TestingSession
     *
     * @param inst    : This method will list Invoices for that Institution
     * @param testingSession : This method will list Invoices for that TestingSession
     * @param em  : Object managing persistence layer
     * @return List<Invoice> : List of all Invoices matching with this Institution and this TestingSession
     */
    public static Invoice getInvoiceForAnInstitutionAndATestingSession(EntityManager em, Institution inst,
            TestingSession testingSession) {
        InvoiceQuery q = new InvoiceQuery();
        if (inst != null) {
            q.institution().eq(inst);
        }
        if (testingSession != null) {
            q.testingSession().eq(testingSession);
        }

        List<Invoice> li = q.getList();
        if ((li != null) && (li.size() > 0)) {
            return li.get(0);
        }
        return null;
    }

    public static Invoice getInvoiceInSessionWithNumber(TestingSession ts, int number) {
        InvoiceQuery q = new InvoiceQuery();
        q.invoiceNumber().eq(number);
        q.testingSession().eq(ts);

        Invoice toReturn = null;
        try {
            toReturn = (Invoice) q.getUniqueResult();

        } catch (NoResultException e) {
        }
        return toReturn;
    }

    public boolean discountGreatherThan0() {
        return this.feesDiscount.compareTo(new BigDecimal(0)) > 0;
    }

    @Override
    public String toString() {
        return "Invoice [id=" + id + ", institution=" + institution + ", testingSession=" + testingSession
                + ", purchaseOrder=" + purchaseOrder + ", invoiceGenerationDate=" + invoiceGenerationDate
                + ", invoicePaid=" + invoicePaid + ", invoiceRelativePath=" + invoiceRelativePath + ", vatNumber="
                + vatNumber + ", vatCountry=" + vatCountry + ", vatValidity=" + vatValidity + ", vatDue=" + vatDue
                + ", vatAmount=" + vatAmount + ", contractReceived=" + contractReceived + ", contractReceivedDate="
                + contractReceivedDate + ", invoiceSent=" + invoiceSent + ", invoiceSentDate=" + invoiceSentDate
                + ", invoiceNumber=" + invoiceNumber + ", invoicePaymentDate=" + invoicePaymentDate + ", feesPaid="
                + feesPaid + ", feesDiscount=" + feesDiscount + ", reasonsForDiscount=" + reasonsForDiscount
                + ", feesDue=" + feesDue + ", feesAmount=" + feesAmount + ", currency=" + currency + ", note=" + note
                + ", numberParticipant=" + numberParticipant + ", numberExtraParticipant=" + numberExtraParticipant
                + ", numberSystem=" + numberSystem + ", lastGenerationDate=" + lastGenerationDate + "]";
    }

    public static Invoice mergeInvoiceIfNotSent(Invoice invoice, EntityManager em) {
        if (invoice != null) {
            if (invoice.invoiceSent != null) {
                if (invoice.invoiceSent) {
                    if (invoice.invoiceSentDate.before(new Date())) {

                        em.clear();
                        return invoice;
                    }
                }
            }
            if (invoice.contractOutOfDate == null) {
                invoice.contractOutOfDate = false;
            }
            if ((invoice.contractOutOfDate != null) && (!invoice.contractOutOfDate)) {
                invoice.contractOutOfDate = invoice.verifyIfThereIsModificationWithDatabaseAsVendor();
            }
            invoice = em.merge(invoice);
            em.flush();
            return invoice;
        }
        return null;
    }

    private boolean verifyIfThereIsModificationWithDatabaseAsVendor() {
        if (this.id != null) {
            InvoiceQuery q = new InvoiceQuery();
            q.id().eq(this.getId());
            List<Invoice> res = q.getList();
            if ((res == null) || (res.size() == 0)) {
                return true;
            }
            Invoice origin = res.get(0);
            boolean areEqual = this.equalInvoiceAsVendor(origin);
            return (!areEqual);
        }
        return true;
    }

    public boolean equalInvoiceAsVendor(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        Invoice other = (Invoice) obj;

        if (this.numberSystem == null) {
            this.numberSystem = 0;
        }
        if (this.numberParticipant == null) {
            this.numberParticipant = 0;
        }
        if (this.numberExtraParticipant == null) {
            this.numberExtraParticipant = 0;
        }

        if (other.numberSystem == null) {
            other.numberSystem = 0;
        }
        if (other.numberParticipant == null) {
            other.numberParticipant = 0;
        }
        if (other.numberExtraParticipant == null) {
            other.numberExtraParticipant = 0;
        }

        if (currency == null) {
            if (other.currency != null) {
                return false;
            }
        } else if (!currency.equals(other.currency)) {
            return false;
        }
        if (feesAmount == null) {
            if (other.feesAmount != null) {
                return false;
            }
        } else if (!feesAmount.equals(other.feesAmount)) {
            return false;
        }
        if (feesDiscount == null) {
            if (other.feesDiscount != null) {
                return false;
            }
        } else if (!feesDiscount.equals(other.feesDiscount)) {
            return false;
        }
        if (numberExtraParticipant == null) {
            if (other.numberExtraParticipant != null) {
                return false;
            }
        } else if (!numberExtraParticipant.equals(other.numberExtraParticipant)) {
            return false;
        }
        if (numberParticipant == null) {
            if (other.numberParticipant != null) {
                return false;
            }
        } else if (!numberParticipant.equals(other.numberParticipant)) {
            return false;
        }
        if (numberSystem == null) {
            if (other.numberSystem != null) {
                return false;
            }
        } else if (!numberSystem.equals(other.numberSystem)) {
            return false;
        }
        if (reasonsForDiscount == null) {
            if (other.reasonsForDiscount != null) {
                return false;
            }
        } else if (!reasonsForDiscount.equals(other.reasonsForDiscount)) {
            return false;
        }
        if (vatAmount == null) {
            if (other.vatAmount != null) {
                return false;
            }
        } else if (!vatAmount.equals(other.vatAmount)) {
            return false;
        }
        return true;
    }

    public static Invoice mergeInvoice(Invoice invoice, EntityManager em) {
        if (invoice != null) {
            if (invoice.contractOutOfDate == null) {
                invoice.contractOutOfDate = false;
            }
            if ((invoice.contractOutOfDate != null) && (!invoice.contractOutOfDate)) {
                invoice.contractOutOfDate = invoice.verifyIfThereIsModificationWithDatabaseAsVendor();
            }
            invoice = em.merge(invoice);
            em.flush();
            return invoice;
        }
        return null;
    }

    /**
     * Returns the total amount to pay by the vendor with the currency : eg. EUR 15000.00
     *
     * @return totalFeeToPay : Amount to pay, with taxes included
     */
    public String getTotalFeeToPayAsCurrency() {

        if (vatAmount == null) {
            return "Internal Error : feeVAT not calculated";
        }
        if (feesAmount == null) {
            return "Internal Error : fee not calculated";
        }

        BigDecimal totalFeeToPay = feesAmount.add(vatAmount);
        if (feesDiscount != null) {
            totalFeeToPay = totalFeeToPay.add(feesDiscount.negate());
        }
        return currency + " " + totalFeeToPay;
    }

    public int calculateNumberExtraParticipant() {
        int res = 0;
        if (this.numberParticipant != null) {
            if (this.numberParticipant > 0) {
                if (this.numberSystem != null) {
                    if (this.numberSystem > 0) {
                        if ((this.numberParticipant - (testingSession.getNbParticipantsIncludedInSystemFees() * this.numberSystem)) > 0) {
                            res = (this.numberParticipant - (testingSession.getNbParticipantsIncludedInSystemFees() * this.numberSystem));
                        }
                    }
                }
            }
        }
        return res;
    }

}
